---
include:
  - local: docker/generic.yml

variables:
  STACK_DEPLOY_DEFAULT_ARGS: --prune --detach=false --quiet
  DOCKER_STACK_DEPLOY_COMPOSE_FILE: docker-compose.yml

docker:deploy:stack:
  extends: .docker:generic
  stage: deploy
  script:
    - !reference [".docker:login", script]
    - !reference [".docker:download", script]
    - !reference [".docker:network", script]
    - |
      if test -f docker-compose.override.yml; then
        EXTRA_CONFIG="-c docker-compose.override.yml"
        EXTRA_COMPOSE_CONFIG="-f docker-compose.override.yml"
      fi
    - docker compose -f ${DOCKER_STACK_DEPLOY_COMPOSE_FILE} ${EXTRA_COMPOSE_CONFIG} pull
    - >
      docker stack deploy
      -c ${DOCKER_STACK_DEPLOY_COMPOSE_FILE}
      ${EXTRA_CONFIG}
      ${DEPLOY_AUTH_ARG}
      ${STACK_DEPLOY_DEFAULT_ARGS}
      ${STACK_DEPLOY_EXTRA_ARGS}
      ${CI_PROJECT_NAME}
